## mingw-w64-libosmscout-2023.03.30.1-3.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(libosmscout VERSION 1.1.1 LANGUAGES C CXX)

# If we are called from conan, include and activate it cmake additions
if(EXISTS ${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  message("Loading conan definitions...")
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup()
endif()

# global settings
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_VERBOSE_MAKEFILE OFF)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/" "$ENV{QTDIR}" "${QTDIR}" "$ENV{QTDIR}/lib/cmake" "${QTDIR}/lib/cmake")
if(NOT CMAKE_DEBUG_POSTFIX)
  if(APPLE)
    set(CMAKE_DEBUG_POSTFIX _debug)
  else()
    set(CMAKE_DEBUG_POSTFIX d)
  endif()
endif()
set(OSMSCOUT_BASE_DIR_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(OSMSCOUT_BASE_DIR_BUILD ${CMAKE_CURRENT_BINARY_DIR})
set(OSMSCOUT_LIBRARY_VERSION ${PROJECT_VERSION})
include_directories(${OSMSCOUT_BASE_DIR_BUILD}/include)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
if(IOS)
  set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "" FORCE)
else()
  option(BUILD_SHARED_LIBS "Shared libraries" ON)
endif()

# default build type
if(CMAKE_BUILD_TYPE STREQUAL "")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build, options are: None (CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# check minimal compiler
if(MSVC)
  if(MSVC_VERSION LESS 1900)
    message(FATAL_ERROR "For minimal support of C++17 at least Visual Studio 2015 is required!")
  endif()
endif()
# TODO: check gcc, clang, etc. version for C++17

# feature detection (libraries, header, etc.)
include(features)

# options
option(OSMSCOUT_BUILD_WITH_OPENMP "Enable OpenMP support" ${OPENMP_FOUND})
if(OSMSCOUT_BUILD_WITH_OPENMP)
  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  else()
    message(FATAL_ERROR "OpenMP support enabled, but not supported")
  endif()
endif()

option(OSMSCOUT_BUILD_IMPORT_TOOL_FOR_DISTRIBUTION "Import tool for distribution" OFF)
if(APPLE)
  option(OSMSCOUT_BUILD_FRAMEWORKS "Enable build of libraries as frameworks" ON)
endif()

# options for extra debugging of map renderer
option(OSMSCOUT_DEBUG_LABEL_LAYOUTER "Print extra debug messages during label layouting" OFF)
option(OSMSCOUT_DEBUG_GROUNDTILES "Print extra debug messages while rendering ground tiles" OFF)

# options for extra debugging of import
option(OSMSCOUT_DEBUG_COASTLINE "Print extra debug messages while importing coastline" OFF)
option(OSMSCOUT_DEBUG_TILING "Print extra debug messages related with map tiles" OFF)

# options for extra debugging of routing
option(OSMSCOUT_DEBUG_ROUTING "Print extra debug messages while routing" OFF)

# compiler settings
include(CheckCXXCompilerFlag)
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX OR CMAKE_COMPILER_IS_GNUCC)
  set(OSMSCOUT_WARNING_FLAGS "-Wall -Winit-self -Wno-overloaded-virtual -Wcast-qual -Wwrite-strings -Wextra -Wno-long-long")
  if(EMSCRIPTEN)
    set(OSMSCOUT_WARNING_FLAGS "${OSMSCOUT_WARNING_FLAGS} -Wno-warn-absolute-paths")
  elseif(NOT APPLE)
    set(OSMSCOUT_WARNING_FLAGS "${OSMSCOUT_WARNING_FLAGS} -Wno-unused-but-set-parameter")
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OSMSCOUT_WARNING_FLAGS}")
  if(UNIX)
    add_definitions(-ldl -lm -lpthread)
  endif()
endif()
if(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /we4028")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fp:fast /wd4251 /MP")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Oi")
  if(OSMSCOUT_PLATFORM_X64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
  endif()
  add_definitions(-D_WIN32_WINNT=0x0A00 -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
endif()
if(MINGW OR MSYS)
  add_definitions(-D_WIN32_WINNT=0x0600)
  if(NOT OSMSCOUT_PLATFORM_X64)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=i686")
    # provide more addressable memory on win 32bit builds
    # see https://msdn.microsoft.com/en-us/library/aa366778
    set(CMAKE_EXE_LINKER_FLAGS "-Wl,--large-address-aware")
  endif ()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -fno-tree-slp-vectorize -Wno-error=cast-qual -Wno-unused-local-typedefs")
endif()
if((CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX OR CMAKE_COMPILER_IS_GNUCC) AND NOT MINGW)
  add_definitions( -Wall -pedantic )
  check_cxx_compiler_flag(-fvisibility=hidden OSMSCOUT_GCC_VISIBILITY)
  if(OSMSCOUT_GCC_VISIBILITY)
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE OSMSCOUT_GCC_VERSION)
    message(STATUS "Detected g++ ${OSMSCOUT_GCC_VERSION}")
    message(STATUS "Enabling GCC visibility flags")
    set(OSMSCOUT_GCC_VISIBILITY_FLAGS "-fvisibility=hidden")
    set(XCODE_ATTRIBUTE_GCC_SYMBOLS_PRIVATE_EXTERN "YES")
    string(TOLOWER "${CMAKE_BUILD_TYPE}" OSMSCOUT_BUILD_TYPE)

    if(OSMSCOUT_BUILD_TYPE STREQUAL "debug" AND OSMSCOUT_GCC_VERSION VERSION_LESS "4.2")
      message(STATUS "Skipping -fvisibility-inlines-hidden due to possible bug in g++ < 4.2")
    else()
      if(APPLE)
        message(STATUS "Skipping -fvisibility-inlines-hidden due to linker issues")
        set(XCODE_ATTRIBUTE_GCC_INLINES_ARE_PRIVATE_EXTERN[arch=x86_64] "YES")
      else()
        set(OSMSCOUT_VISIBILITY_FLAGS "${OSMSCOUT_GCC_VISIBILITY_FLAGS} -fvisibility-inlines-hidden")
        set(XCODE_ATTRIBUTE_GCC_INLINES_ARE_PRIVATE_EXTERN "YES")
      endif()
    endif()
  endif()
  if(NOT APPLE)
    add_definitions(-fPIC)
  endif()
endif()
if(APPLE)
  if(IOS)
    set(CMAKE_SIZEOF_VOID_P 4)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fobjc-arc -fembed-bitcode")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fobjc-arc")
  endif()
  set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++17")
  set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
endif()
if(NOT BUILD_SHARED_LIBS)
  add_definitions(-DOSMSCOUT_STATIC)
endif()
include(ProjectConfig)
add_definitions(-D_USE_MATH_DEFINES)

# Test large file support
include(TestLargeFiles)
OPJ_TEST_LARGE_FILES(OPJ_HAVE_LARGEFILES)

# Qt DLLs
if(WIN32 AND TARGET Qt5::qmake AND NOT TARGET Qt5::windeployqt)
  get_target_property(_qt5_qmake_location Qt5::qmake IMPORTED_LOCATION)
  execute_process(
    COMMAND "${_qt5_qmake_location}" -query QT_INSTALL_PREFIX
    RESULT_VARIABLE return_code
    OUTPUT_VARIABLE qt5_install_prefix
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  set(imported_location "${qt5_install_prefix}/bin/windeployqt.exe")
  if(EXISTS ${imported_location})
    add_executable(Qt5::windeployqt IMPORTED)
    set_target_properties(Qt5::windeployqt PROPERTIES IMPORTED_LOCATION ${imported_location})
  endif()
  option(OSMSCOUT_INSTALL_QT_DLL "Copies the DLLs from Qt to the installation directory" OFF)
  mark_as_advanced(OSMSCOUT_INSTALL_QT_DLL)
endif()

# components
set(OSMSCOUT_BUILD_CORE ON CACHE INTERNAL "" FORCE)
add_subdirectory(libosmscout)

option(OSMSCOUT_BUILD_IMPORT "Enable build of import library" ON)
if(OSMSCOUT_BUILD_IMPORT)
  add_subdirectory(libosmscout-import)
endif()

option(OSMSCOUT_BUILD_GPX "Enable build of gpx library" ON)
if(OSMSCOUT_BUILD_GPX)
  add_subdirectory(libosmscout-gpx)
endif()

set(OSMSCOUT_BUILD_MAP ON CACHE INTERNAL "" FORCE)
add_subdirectory(libosmscout-map)

if(LIBAGG_FOUND AND LIBAGGFT2_LIBRARIES AND FREETYPE_FOUND AND OSMSCOUT_BUILD_MAP)
  set(OSMSCOUT_BUILD_MAP_AGG_CACHE ON)
else()
  set(OSMSCOUT_BUILD_MAP_AGG_CACHE OFF)
endif()
option(OSMSCOUT_BUILD_MAP_AGG "Enable build of agg map drawing backend" ${OSMSCOUT_BUILD_MAP_AGG_CACHE})
if(OSMSCOUT_BUILD_MAP_AGG)
  if(NOT ${OSMSCOUT_BUILD_MAP})
    message(SEND_ERROR "The main map drawing interface is required for agg map drawing backend")
	set(OSMSCOUT_BUILD_MAP_AGG OFF)
  endif()
  if(NOT LIBAGG_FOUND)
    message(SEND_ERROR "libagg is required for agg map drawing backend")
	set(OSMSCOUT_BUILD_MAP_AGG OFF)
  endif()
  if(NOT LIBAGGFT2_LIBRARIES)
    message(SEND_ERROR "libaggft2 is required for agg map drawing backend")
	set(OSMSCOUT_BUILD_MAP_AGG OFF)
  endif()
  if(NOT FREETYPE_FOUND)
    message(SEND_ERROR "freetype2 is required for agg map drawing backend")
	set(OSMSCOUT_BUILD_MAP_AGG OFF)
  endif()
  if(OSMSCOUT_BUILD_MAP_AGG)
    add_subdirectory(libosmscout-map-agg)
  endif()
endif()

if(CAIRO_FOUND AND PNG_FOUND AND OSMSCOUT_BUILD_MAP)
  set(OSMSCOUT_BUILD_MAP_CAIRO_CACHE ON)
else()
  set(OSMSCOUT_BUILD_MAP_CAIRO_CACHE OFF)
endif()
option(OSMSCOUT_BUILD_MAP_CAIRO "Enable build of cairo map drawing backend" ${OSMSCOUT_BUILD_MAP_CAIRO_CACHE})
if(OSMSCOUT_BUILD_MAP_CAIRO)
  if(NOT ${OSMSCOUT_BUILD_MAP})
    message(SEND_ERROR "The main map drawing interface is required for cairo map drawing backend")
    set(OSMSCOUT_BUILD_MAP_CAIRO OFF)
  endif()
  if(NOT CAIRO_FOUND)
    message(SEND_ERROR "Cairo is required for cairo map drawing backend")
    set(OSMSCOUT_BUILD_MAP_CAIRO OFF)
  endif()
  if(NOT PNG_FOUND)
    message(SEND_ERROR "libpng is required for cairo map drawing backend")
    set(OSMSCOUT_BUILD_MAP_CAIRO OFF)
  endif()
  if(OSMSCOUT_BUILD_MAP_CAIRO)
    add_subdirectory(libosmscout-map-cairo)
  endif()
endif()

if(WIN32)
  if(Direct2D_FOUND AND OSMSCOUT_BUILD_MAP AND NOT MSYS)
    set(OSMSCOUT_BUILD_MAP_DIRECTX_CACHE ON)
  else()
    set(OSMSCOUT_BUILD_MAP_DIRECTX_CACHE OFF)
  endif()
  option(OSMSCOUT_BUILD_MAP_DIRECTX "Enable build of DirectX map drawing backend" ${OSMSCOUT_BUILD_MAP_DIRECTX_CACHE})
  option(OSMSCOUT_BUILD_MAP_GDI "Enable build of GDI+ map drawing backend" ON)
else()
  set(OSMSCOUT_BUILD_MAP_DIRECTX OFF)
  set(OSMSCOUT_BUILD_MAP_GDI OFF)
endif()
if(OSMSCOUT_BUILD_MAP_DIRECTX)
  if(NOT ${OSMSCOUT_BUILD_MAP})
    message(SEND_ERROR "The main map drawing interface is required for DirectX map drawing backend")
    set(OSMSCOUT_BUILD_MAP_DIRECTX OFF)
  endif()
  if(NOT Direct2D_FOUND)
    message(SEND_ERROR "Direct2D is required for DirectX map drawing backend")
    set(OSMSCOUT_BUILD_MAP_DIRECTX OFF)
  endif()
  if(OSMSCOUT_BUILD_MAP_DIRECTX)
    add_subdirectory(libosmscout-map-directx)
  endif()
endif()
if(OSMSCOUT_BUILD_MAP_GDI)
  if(NOT ${OSMSCOUT_BUILD_MAP})
    message(SEND_ERROR "The main map drawing interface is required for GDI+ map drawing backend")
    set(OSMSCOUT_BUILD_MAP_GDI OFF)
  endif()
  if(OSMSCOUT_BUILD_MAP_GDI)
    add_subdirectory(libosmscout-map-gdi)
  endif()
endif(OSMSCOUT_BUILD_MAP_GDI)

if(APPLE)
  option(OSMSCOUT_BUILD_MAP_IOSX "Enable build of iOS/OSX map drawing backend" ${OSMSCOUT_BUILD_MAP})
  if(OSMSCOUT_BUILD_MAP_IOSX)
    if(NOT ${OSMSCOUT_BUILD_MAP})
      message(SEND_ERROR "The main map drawing interface is required for cairo map drawing backend")
      set(OSMSCOUT_BUILD_MAP_IOSX OFF)
    endif()
    if(OSMSCOUT_BUILD_MAP_IOSX)
      add_subdirectory(libosmscout-map-iosx)
    endif()
  endif()
else()
  set(OSMSCOUT_BUILD_MAP_IOSX OFF CACHE INTERNAL "" FORCE)
endif()

if(OPENGL_FOUND AND GLEW_FOUND AND GLM_FOUND AND PNG_FOUND AND OSMSCOUT_BUILD_MAP)
  set(OSMSCOUT_BUILD_MAP_OPENGL_CACHE ON)
else()
  set(OSMSCOUT_BUILD_MAP_OPENGL_CACHE OFF)
endif()
option(OSMSCOUT_BUILD_MAP_OPENGL "Enable build of OpenGL map drawing backend" ${OSMSCOUT_BUILD_MAP_OPENGL_CACHE})
if(OSMSCOUT_BUILD_MAP_OPENGL)
  if(NOT ${OSMSCOUT_BUILD_MAP})
    message(SEND_ERROR "The main map drawing interface is required for OpenGL map drawing backend")
	set(OSMSCOUT_BUILD_MAP_OPENGL OFF)
  endif()
  if(NOT PNG_FOUND)
    message(SEND_ERROR "libpng is required for OpenGL map drawing backend")
	set(OSMSCOUT_BUILD_MAP_OPENGL OFF)
  endif()
  if(NOT FREETYPE_FOUND)
    message(SEND_ERROR "freetype2 is required for OpenGL map drawing backend")
	set(OSMSCOUT_BUILD_MAP_OPENGL OFF)
  endif()
  if(NOT GLEW_FOUND)
    message(SEND_ERROR "GLEW is required for OpenGL map drawing backend")
	set(OSMSCOUT_BUILD_MAP_OPENGL OFF)
  endif()
  if(NOT GLM_FOUND)
    message(SEND_ERROR "GLM is required for OpenGL map drawing backend")

=== BasemapImport/CMakeLists.txt ===
set(OSMSCOUT_BUILD_IMPORT ON CACHE INTERNAL "" FORCE)

set(SOURCE_FILES
    src/BasemapImport.cpp
)

add_executable(BasemapImport ${SOURCE_FILES} ${HEADER_FILES})

set_target_properties(BasemapImport PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Tools")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/Config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/Config.h)

target_include_directories(BasemapImport PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/include)

target_link_libraries(BasemapImport OSMScout::Import)

if(OSMSCOUT_BUILD_IMPORT_TOOL_FOR_DISTRIBUTION AND (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX OR CMAKE_COMPILER_IS_GNUCC))
  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++")
endif()
if(WIN32)
	create_win32_tool_resource(BasemapImport)
endif()

install(TARGETS BasemapImport
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

=== Import/CMakeLists.txt ===
set(OSMSCOUT_BUILD_IMPORT ON CACHE INTERNAL "" FORCE)

set(SOURCE_FILES
    src/Import.cpp
)

add_executable(Import ${SOURCE_FILES} ${HEADER_FILES})

set_target_properties(Import PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Tools")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/Config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/Config.h)

target_include_directories(Import PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/include)

target_link_libraries(Import OSMScout::Import)

if(OSMSCOUT_BUILD_IMPORT_TOOL_FOR_DISTRIBUTION AND (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX OR CMAKE_COMPILER_IS_GNUCC))
  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++")
endif()
if(WIN32)
	create_win32_tool_resource(Import)
endif()

install(TARGETS Import
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

=== PublicTransportMap/CMakeLists.txt ===
set(SOURCE_FILES
    src/PublicTransportMap.cpp
)

add_executable(PublicTransportMap ${SOURCE_FILES})

set_target_properties(PublicTransportMap PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Tools")

target_link_libraries(PublicTransportMap OSMScout::OSMScout)

if(WIN32)
	create_win32_tool_resource(PublicTransportMap)
endif()

install(TARGETS PublicTransportMap
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

=== libosmscout-client-qt/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(HEADER_FILES
		include/osmscoutclientqt/AdminRegionInfo.h
		include/osmscoutclientqt/ClientQtImportExport.h
    include/osmscoutclientqt/DBThread.h
    include/osmscoutclientqt/DBInstance.h
    include/osmscoutclientqt/ElevationChartWidget.h
    include/osmscoutclientqt/ElevationModule.h
    include/osmscoutclientqt/FileDownloader.h
    include/osmscoutclientqt/IconAnimation.h
    include/osmscoutclientqt/IconLookup.h
    include/osmscoutclientqt/InputHandler.h
    include/osmscoutclientqt/LocationEntry.h
    include/osmscoutclientqt/LocationInfoModel.h
    include/osmscoutclientqt/MapWidget.h
    include/osmscoutclientqt/OnlineTileProvider.h
    include/osmscoutclientqt/OnlineTileProviderModel.h
    include/osmscoutclientqt/OsmTileDownloader.h
    include/osmscoutclientqt/OSMTile.h
    include/osmscoutclientqt/RoutingModel.h
    include/osmscoutclientqt/Router.h
    include/osmscoutclientqt/SearchLocationModel.h
    include/osmscoutclientqt/Settings.h
    include/osmscoutclientqt/TileCache.h
    include/osmscoutclientqt/MapProvider.h
    include/osmscoutclientqt/AvailableMapsModel.h
    include/osmscoutclientqt/PersistentCookieJar.h
    include/osmscoutclientqt/MapManager.h
    include/osmscoutclientqt/MapDownloadsModel.h
    include/osmscoutclientqt/MapObjectInfoModel.h
    include/osmscoutclientqt/MapStyleModel.h
    include/osmscoutclientqt/StyleFlagsModel.h
    include/osmscoutclientqt/OSMScoutQt.h
    include/osmscoutclientqt/DBJob.h
    include/osmscoutclientqt/LookupModule.h
    include/osmscoutclientqt/SearchModule.h
    include/osmscoutclientqt/StyleModule.h
    include/osmscoutclientqt/SunriseSunset.h
    include/osmscoutclientqt/MapRenderer.h
    include/osmscoutclientqt/PlaneMapRenderer.h
    include/osmscoutclientqt/TiledMapRenderer.h
    include/osmscoutclientqt/OverlayObject.h
    include/osmscoutclientqt/MapOverlay.h
    include/osmscoutclientqt/TiledMapOverlay.h
    include/osmscoutclientqt/TiledRenderingHelper.h
    include/osmscoutclientqt/NavigationModule.h
    include/osmscoutclientqt/RouteDescriptionBuilder.h
    include/osmscoutclientqt/NavigationModel.h
    include/osmscoutclientqt/VehiclePosition.h
    include/osmscoutclientqt/QmlRoutingProfile.h
    include/osmscoutclientqt/QtRouteData.h
    include/osmscoutclientqt/RouteStep.h
    include/osmscoutclientqt/NearPOIModel.h
    include/osmscoutclientqt/POILookupModule.h
    include/osmscoutclientqt/InstalledMapsModel.h
    include/osmscoutclientqt/Voice.h
    include/osmscoutclientqt/VoiceManager.h
    include/osmscoutclientqt/AvailableVoicesModel.h
    include/osmscoutclientqt/VoiceProvider.h
    include/osmscoutclientqt/InstalledVoicesModel.h
)

set(SOURCE_FILES
    src/osmscoutclientqt/DBThread.cpp
    src/osmscoutclientqt/DBInstance.cpp
    src/osmscoutclientqt/ElevationChartWidget.cpp
    src/osmscoutclientqt/ElevationModule.cpp
    src/osmscoutclientqt/FileDownloader.cpp
    src/osmscoutclientqt/IconAnimation.cpp
    src/osmscoutclientqt/IconLookup.cpp
    src/osmscoutclientqt/InputHandler.cpp
    src/osmscoutclientqt/LocationEntry.cpp
    src/osmscoutclientqt/LocationInfoModel.cpp
    src/osmscoutclientqt/MapWidget.cpp
    src/osmscoutclientqt/OnlineTileProvider.cpp
    src/osmscoutclientqt/OnlineTileProviderModel.cpp
    src/osmscoutclientqt/OSMTile.cpp
    src/osmscoutclientqt/OsmTileDownloader.cpp
    src/osmscoutclientqt/RoutingModel.cpp
    src/osmscoutclientqt/Router.cpp
    src/osmscoutclientqt/SearchLocationModel.cpp
    src/osmscoutclientqt/Settings.cpp
    src/osmscoutclientqt/TileCache.cpp
    src/osmscoutclientqt/MapProvider.cpp
    src/osmscoutclientqt/AvailableMapsModel.cpp
    src/osmscoutclientqt/MapManager.cpp
    src/osmscoutclientqt/MapDownloadsModel.cpp
    src/osmscoutclientqt/MapObjectInfoModel.cpp
    src/osmscoutclientqt/MapStyleModel.cpp
    src/osmscoutclientqt/StyleFlagsModel.cpp
    src/osmscoutclientqt/OSMScoutQt.cpp
    src/osmscoutclientqt/DBJob.cpp
    src/osmscoutclientqt/LookupModule.cpp
    src/osmscoutclientqt/SearchModule.cpp
    src/osmscoutclientqt/StyleModule.cpp
    src/osmscoutclientqt/SunriseSunset.cpp
    src/osmscoutclientqt/MapRenderer.cpp
    src/osmscoutclientqt/PlaneMapRenderer.cpp
    src/osmscoutclientqt/TiledMapRenderer.cpp
    src/osmscoutclientqt/OverlayObject.cpp
    src/osmscoutclientqt/MapOverlay.cpp
    src/osmscoutclientqt/TiledMapOverlay.cpp
    src/osmscoutclientqt/TiledRenderingHelper.cpp
    src/osmscoutclientqt/NavigationModule.cpp
    src/osmscoutclientqt/RouteDescriptionBuilder.cpp
    src/osmscoutclientqt/NavigationModel.cpp
    src/osmscoutclientqt/VehiclePosition.cpp
    src/osmscoutclientqt/RouteStep.cpp
    src/osmscoutclientqt/QmlRoutingProfile.cpp
    src/osmscoutclientqt/QtRouteData.cpp
    src/osmscoutclientqt/NearPOIModel.cpp
    src/osmscoutclientqt/POILookupModule.cpp
    src/osmscoutclientqt/InstalledMapsModel.cpp
    src/osmscoutclientqt/Voice.cpp
    src/osmscoutclientqt/VoiceManager.cpp
    src/osmscoutclientqt/AvailableVoicesModel.cpp
    src/osmscoutclientqt/VoiceProvider.cpp
    src/osmscoutclientqt/InstalledVoicesModel.cpp
)

osmscout_library_project(
	NAME OSMScoutClientQt
	ALIAS ClientQt
	OUTPUT_NAME "osmscout_client_qt"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR osmscoutclientqt
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutclientqt/ClientQtFeatures.h.cmake
	TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt Qt5::Core Qt5::Gui Qt5::Quick Qt5::Multimedia
)

if(MARISA_FOUND)
    target_include_directories(OSMScoutClientQt PUBLIC ${MARISA_INCLUDE_DIRS})
    target_link_libraries(OSMScoutClientQt ${MARISA_LIBRARIES})
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutClientQt PROPERTIES
		FRAMEWORK TRUE
		FRAMEWORK_VERSION C
		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
		PUBLIC_HEADER     "${HEADER_FILES}"
		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutClientQt")
endif()

=== libosmscout-import/CMakeLists.txt ===
set(HEADER_FILES
    include/osmscoutimport/AreaIndexGenerator.h
    include/osmscoutimport/GenAreaAreaIndex.h
    include/osmscoutimport/GenAreaNodeIndex.h
    include/osmscoutimport/GenAreaWayIndex.h
    include/osmscoutimport/GenCoordDat.h
    include/osmscoutimport/GenCoverageIndex.h
    include/osmscoutimport/GenIntersectionIndex.h
    include/osmscoutimport/GenLocationIndex.h
    include/osmscoutimport/GenMergeAreas.h
    include/osmscoutimport/GenNodeDat.h
    include/osmscoutimport/GenNumericIndex.h
    include/osmscoutimport/GenOptimizeAreasLowZoom.h
    include/osmscoutimport/GenOptimizeAreaWayIds.h
    include/osmscoutimport/GenOptimizeWaysLowZoom.h
    include/osmscoutimport/GenPTRouteDat.h
    include/osmscoutimport/GenRawNodeIndex.h
    include/osmscoutimport/GenRawRelIndex.h
    include/osmscoutimport/GenAreaRouteIndex.h
    include/osmscoutimport/GenRawWayIndex.h
    include/osmscoutimport/GenRelAreaDat.h
    include/osmscoutimport/GenRouteDat.h
    include/osmscoutimport/GenRoute2Dat.h
    include/osmscoutimport/GenTypeDat.h
    include/osmscoutimport/GenWaterIndex.h
    include/osmscoutimport/GenWayAreaDat.h
    include/osmscoutimport/GenWayWayDat.h
    include/osmscoutimport/Import.h
    include/osmscoutimport/ImportErrorReporter.h
    include/osmscoutimport/ImportModule.h
    include/osmscoutimport/ImportParameter.h
    include/osmscoutimport/ImportProgress.h
    include/osmscoutimport/MergeAreaData.h
    include/osmscoutimport/Preprocess.h
    include/osmscoutimport/Preprocessor.h
    include/osmscoutimport/PreprocessPoly.h
    include/osmscoutimport/RawCoastline.h
    include/osmscoutimport/RawCoord.h
    include/osmscoutimport/RawNode.h
    include/osmscoutimport/RawRelation.h
    include/osmscoutimport/RawRelIndexedDataFile.h
    include/osmscoutimport/RawWay.h
    include/osmscoutimport/RawWayIndexedDataFile.h
    include/osmscoutimport/ShapeFileScanner.h
    include/osmscoutimport/WaterIndexProcessor.h
    include/osmscoutimport/SortDat.h
    include/osmscoutimport/SortNodeDat.h
    include/osmscoutimport/SortWayDat.h
    include/osmscoutimport/ImportImportExport.h
)

set(SOURCE_FILES
    src/osmscoutimport/AreaIndexGenerator.cpp
    src/osmscoutimport/GenAreaAreaIndex.cpp
    src/osmscoutimport/GenAreaNodeIndex.cpp
    src/osmscoutimport/GenAreaWayIndex.cpp
    src/osmscoutimport/GenCoordDat.cpp
    src/osmscoutimport/GenCoverageIndex.cpp
    src/osmscoutimport/GenIntersectionIndex.cpp
    src/osmscoutimport/GenLocationIndex.cpp
    src/osmscoutimport/GenMergeAreas.cpp
    src/osmscoutimport/GenNodeDat.cpp
    src/osmscoutimport/GenNumericIndex.cpp
    src/osmscoutimport/GenOptimizeAreasLowZoom.cpp
    src/osmscoutimport/GenOptimizeAreaWayIds.cpp
    src/osmscoutimport/GenOptimizeWaysLowZoom.cpp
    src/osmscoutimport/GenRawNodeIndex.cpp
    src/osmscoutimport/GenRawRelIndex.cpp
    src/osmscoutimport/GenAreaRouteIndex.cpp
    src/osmscoutimport/GenRawWayIndex.cpp
    src/osmscoutimport/GenRelAreaDat.cpp
    src/osmscoutimport/GenPTRouteDat.cpp
    src/osmscoutimport/GenRouteDat.cpp
    src/osmscoutimport/GenRoute2Dat.cpp
    src/osmscoutimport/GenTypeDat.cpp
    src/osmscoutimport/GenWaterIndex.cpp
    src/osmscoutimport/GenWayAreaDat.cpp
    src/osmscoutimport/GenWayWayDat.cpp
    src/osmscoutimport/Import.cpp
    src/osmscoutimport/ImportErrorReporter.cpp
    src/osmscoutimport/ImportModule.cpp
    src/osmscoutimport/ImportParameter.cpp
    src/osmscoutimport/ImportProgress.cpp
    src/osmscoutimport/MergeAreaData.cpp
    src/osmscoutimport/Preprocess.cpp
    src/osmscoutimport/Preprocessor.cpp
    src/osmscoutimport/PreprocessPoly.cpp
    src/osmscoutimport/RawCoastline.cpp
    src/osmscoutimport/RawCoord.cpp
    src/osmscoutimport/RawNode.cpp
    src/osmscoutimport/RawRelation.cpp
    src/osmscoutimport/RawRelIndexedDataFile.cpp
    src/osmscoutimport/RawWay.cpp
    src/osmscoutimport/RawWayIndexedDataFile.cpp
    src/osmscoutimport/ShapeFileScanner.cpp
    src/osmscoutimport/WaterIndexProcessor.cpp
    src/osmscoutimport/SortDat.cpp
    src/osmscoutimport/SortNodeDat.cpp
    src/osmscoutimport/SortWayDat.cpp
)

set(EXCLUDE_HEADER)

if(MARISA_FOUND)
    list(APPEND HEADER_FILES include/osmscoutimport/GenTextIndex.h)
    list(APPEND SOURCE_FILES src/osmscoutimport/GenTextIndex.cpp)
else()
	list(APPEND EXCLUDE_HEADER GenTextIndex.h)
endif()

if(LIBXML2_FOUND)
    list(APPEND HEADER_FILES include/osmscoutimport/PreprocessOSM.h)
    list(APPEND SOURCE_FILES src/osmscoutimport/PreprocessOSM.cpp)
else()
	list(APPEND EXCLUDE_HEADER PreprocessOSM.h)
endif()

if (PROTOBUF_FOUND)
    protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS
		${CMAKE_CURRENT_SOURCE_DIR}/src/protobuf/fileformat.proto
		${CMAKE_CURRENT_SOURCE_DIR}/src/protobuf/osmformat.proto)
    list(APPEND HEADER_FILES include/osmscoutimport/PreprocessPBF.h)
    list(APPEND SOURCE_FILES src/osmscoutimport/PreprocessPBF.cpp)
    list(APPEND HEADER_FILES ${PROTO_HDRS})
    list(APPEND SOURCE_FILES ${PROTO_SRCS})
else()
	list(APPEND EXCLUDE_HEADER PreprocessPBF.h ${PROTO_HDRS})
endif()

osmscout_library_project(
	NAME OSMScoutImport
	ALIAS Import
	OUTPUT_NAME "osmscout_import"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR "osmscoutimport"
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutimport/ImportFeatures.h.cmake
	FEATURE ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutimport/ImportFeatures.h
	TARGET OSMScout::OSMScout
	SKIP_HEADER
)

if(LIBXML2_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${LIBXML2_INCLUDE_DIR})
	target_link_libraries(OSMScoutImport ${LIBXML2_LIBRARIES})
endif()

if (PROTOBUF_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${Protobuf_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
	target_link_libraries(OSMScoutImport ${Protobuf_LIBRARIES})
	if(WIN32)
		target_compile_definitions(OSMScoutImport PRIVATE -DPROTOBUF_USE_DLLS)
	endif()
	target_compile_definitions(OSMScoutImport PRIVATE -DOSMSCOUT_IMPORT_CMAKE_BUILD)
endif()

if (ICONV_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${ICONV_INCLUDE_DIRS})
	target_link_libraries(OSMScoutImport ${ICONV_LIBRARIES})
endif()

if (LIBLZMA_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${LIBLZMA_INCLUDE_DIRS})
	target_link_libraries(OSMScoutImport ${LIBLZMA_LIBRARIES})
endif()

if (ZLIB_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${ZLIB_INCLUDE_DIRS})
	target_link_libraries(OSMScoutImport ${ZLIB_LIBRARIES})
endif()

if(MARISA_FOUND)
	target_include_directories(OSMScoutImport PRIVATE ${MARISA_INCLUDE_DIRS})
	target_link_libraries(OSMScoutImport ${MARISA_LIBRARIES})
endif()

if (HAVE_STD_EXECUTION)
	target_link_libraries(OSMScoutImport TBB::tbb)
endif()

if(OpenMP_CXX_FOUND)
	target_link_libraries(OSMScoutImport OpenMP::OpenMP_CXX)
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutImport PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION C
        MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
        #MACOSX_FRAMEWORK_INFO_PLIST Info.plist
        PUBLIC_HEADER     "${HEADER_FILES}"
        CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
        OUTPUT_NAME "OSMScoutImport")
endif()

if(WIN32)
	target_link_libraries(OSMScoutImport Ws2_32.lib)
endif()

if(NOT EXCLUDE_HEADER)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscout DESTINATION include FILES_MATCHING PATTERN "*.h" PATTERN "private" EXCLUDE)
else()
	set(_exclude PATTERN "private" EXCLUDE)
	foreach(ef ${EXCLUDE_HEADER})
		set(_exclude ${_exclude} PATTERN ${ef} EXCLUDE)
	endforeach()
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscout DESTINATION include FILES_MATCHING PATTERN "*.h" ${_exclude})
endif()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutimport/ImportFeatures.h DESTINATION include/osmscout)

=== libosmscout-map-binding/CMakeLists.txt ===
if(OSMSCOUT_BUILD_BINDING_JAVA)
  if(NOT SWIG_FOUND)
    message(SEND_ERROR "swig is required for java binding")
  endif()
  if(NOT JNI_FOUND)
    message(SEND_ERROR "A JDK is required for java binding")
  endif()

  include(${SWIG_USE_FILE})
  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/Java/src/main/java/net/sf/libosmscout/osmscout)
  file(MAKE_DIRECTORY ${CMAKE_SWIG_OUTDIR})
  # See https://github.com/swig/swig/issues/568
  set(CMAKE_SWIG_FLAGS
          -c++
          -package net.sf.libosmscout.osmscout
          -features autodoc=1
          -DSWIGWORDSIZE64
          -I${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout-binding/src/swig
          -I${CMAKE_CURRENT_SOURCE_DIR}/src/swig
          -I${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout/include
          -I${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout-map/include
          -outdir ${CMAKE_SWIG_OUTDIR})
  if(MSVC)
    set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -Fmicrosoft)
  endif()
  set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/src/swig/osmscout/libosmscout-map.i PROPERTIES CPLUSPLUS ON)
  swig_add_library(osmscout_map_binding_java
    LANGUAGE Java
    SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/swig/osmscout/libosmscout-map.i)
  swig_link_libraries(osmscout_map_binding_java OSMScout OSMScoutMap ${JNI_LIBRARIES})
  target_include_directories(osmscout_map_binding_java PRIVATE
    include
    ${CMAKE_CURRENT_BINARY_DIR}/include
    ${JNI_INCLUDE_DIRS}
    ${JAVA_INCLUDE_PATH})
  target_link_libraries(osmscout_map_binding_java
    ${OSMSCOUT_TARGET}
    ${JNI_LIBRARIES})
  set_property(TARGET osmscout_map_binding_java PROPERTY CXX_STANDARD 17)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")

  install(TARGETS osmscout_map_binding_java
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION bin
    ARCHIVE DESTINATION lib)
  install(DIRECTORY ${OSMSCOUT_BASE_DIR_SOURCE}/Java DESTINATION binding)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Java DESTINATION binding FILES_MATCHING PATTERN "*.java" PATTERN "private" EXCLUDE)
endif()

=== libosmscout-map-cairo/CMakeLists.txt ===
set(HEADER_FILES
    include/osmscoutmapcairo/MapCairoImportExport.h
    include/osmscoutmapcairo/LoaderPNG.h
    include/osmscoutmapcairo/MapPainterCairo.h
	include/osmscoutmapcairo/SymbolRendererCairo.h
)

set(SOURCE_FILES
    src/osmscoutmapcairo/LoaderPNG.cpp
    src/osmscoutmapcairo/MapPainterCairo.cpp
	src/osmscoutmapcairo/SymbolRendererCairo.cpp
)

osmscout_library_project(
	NAME OSMScoutMapCairo
	ALIAS MapCairo
	OUTPUT_NAME "osmscout_map_cairo"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR osmscoutmapcairo
	INCLUDES ${CAIRO_INCLUDE_DIRS} ${PNG_INCLUDE_DIRS}
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutmapcairo/MapCairoFeatures.h.cmake
	TARGET OSMScout::OSMScout OSMScout::Map ${CAIRO_LIBRARIES} ${PNG_LIBRARIES}
)
target_include_directories(OSMScoutMapCairo INTERFACE ${CAIRO_INCLUDE_DIRS})

if(PANGOCAIRO_FOUND)
  target_include_directories(OSMScoutMapCairo PUBLIC ${PANGO_INCLUDE_DIRS})
  target_link_libraries(OSMScoutMapCairo ${PANGO_LIBRARIES})
  target_include_directories(OSMScoutMapCairo INTERFACE ${PANGO_INCLUDE_DIRS})

  if(HARFBUZZ_FOUND)
	  target_include_directories(OSMScoutMapCairo PUBLIC ${HARFBUZZ_INCLUDE_DIRS})
	  target_link_libraries(OSMScoutMapCairo ${HARFBUZZ_LIBRARIES})
	  target_include_directories(OSMScoutMapCairo INTERFACE ${HARFBUZZ_INCLUDE_DIRS})
  endif()
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutMapCairo PROPERTIES
  		FRAMEWORK TRUE
  		FRAMEWORK_VERSION C
  		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
  		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
  		PUBLIC_HEADER     "${HEADER_FILES}"
  		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutMapCairo")
endif()

=== libosmscout-map-gdi/CMakeLists.txt ===
set(HEADER_FILES
    include/osmscoutmapgdi/MapGDIImportExport.h
    include/osmscoutmapgdi/MapPainterGDI.h
    include/osmscoutmapgdi/MapPainterGDIWindow.h
)

set(SOURCE_FILES
    src/osmscoutmapgdi/MapPainterGDI.cpp
    src/osmscoutmapgdi/MapPainterGDIWindow.cpp
)

osmscout_library_project(
	NAME OSMScoutMapGDI
	ALIAS MapGDI
	OUTPUT_NAME "osmscout_map_gdi"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR osmscoutmapgdi
	TARGET OSMScout::OSMScout OSMScout::Map Gdiplus
)

=== libosmscout-map-opengl/CMakeLists.txt ===
set(HEADER_FILES
		include/osmscoutmapopengl/MapOpenGLImportExport.h
		include/osmscoutmapopengl/OpenGLMapData.h
		include/osmscoutmapopengl/MapPainterOpenGL.h
		include/osmscoutmapopengl/Triangulate.h
		include/osmscoutmapopengl/OpenGLProjection.h
		include/osmscoutmapopengl/PNGLoaderOpenGL.h
		include/osmscoutmapopengl/ShaderUtils.h
		include/osmscoutmapopengl/TextLoader.h
		include/poly2tri/poly2tri.h
		include/poly2tri/sweep/cdt.h
		include/poly2tri/sweep/sweep.h
		include/poly2tri/common/utils.h
		include/poly2tri/sweep/sweep.h
		include/poly2tri/sweep/advancing_front.h
		)

set(SOURCE_FILES
		src/osmscoutmapopengl/MapPainterOpenGL.cpp
		src/osmscoutmapopengl/Triangulate.cpp
		src/osmscoutmapopengl/PNGLoaderOpenGL.cpp
		src/osmscoutmapopengl/ShaderUtils.cpp
		src/osmscoutmapopengl/TextLoader.cpp
		src/poly2tri/sweep/cdt.cc
		src/poly2tri/common/shapes.cc
		src/poly2tri/sweep/sweep.cc
		src/poly2tri/sweep/sweep_context.cc
		src/poly2tri/sweep/advancing_front.cc)

set(SHADER_FILES
	data/shaders/AreaFragmentShader.frag
	data/shaders/TextVertexShader.vert
	data/shaders/QuadFragmentShader.frag
	data/shaders/QuadVertexShader.vert
	data/shaders/PathFragmentShader.frag
	data/shaders/AreaVertexShader.vert
	data/shaders/GroundFragmentShader.frag
	data/shaders/PathVertexShader.vert
	data/shaders/Projection.vert
	data/shaders/GroundVertexShader.vert
	data/shaders/TextFragmentShader.frag)

set(FONT_FILES
	data/fonts/LiberationSans-Regular.ttf
	data/fonts/LICENSE)

# install shaders
if(APPLE)
	set(SHADER_INSTALL_DIR "/Library/Application Support/osmscout/shaders")
	set(FONTS_INSTALL_DIR "/Library/Application Support/osmscout/fonts")
elseif(WIN32)
	set(SHADER_INSTALL_DIR "C:/ProgramData/osmscout/shaders")
	set(FONTS_INSTALL_DIR "C:/ProgramData/osmscout/fonts")
else() # Linux
	set(SHADER_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/osmscout/shaders")
	set(FONTS_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/osmscout/fonts")
endif()
install(FILES ${SHADER_FILES}
		DESTINATION ${SHADER_INSTALL_DIR})
install(FILES ${FONT_FILES}
	    DESTINATION ${FONTS_INSTALL_DIR})
set(DEFAULT_FONT_FILE "${FONTS_INSTALL_DIR}/LiberationSans-Regular.ttf")

osmscout_library_project(
	NAME OSMScoutMapOpenGL
	ALIAS MapOpenGL
	OUTPUT_NAME "osmscout_map_opengl"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR osmscoutmapopengl
	INCLUDES ${OPENGL_INCLUDE_DIR} ${GLEW_INCLUDE_DIRS} ${GLM_INCLUDE_DIRS} ${PNG_INCLUDE_DIRS} ${FREETYPE_INCLUDE_DIRS}
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutmapopengl/MapOpenGLFeatures.h.cmake
	TARGET OSMScout::OSMScout OSMScout::Map ${OPENGL_LIBRARIES} GLEW::GLEW ${PNG_LIBRARIES} ${FREETYPE_LIBRARIES}
)
target_include_directories(OSMScoutMapOpenGL INTERFACE ${OPENGL_INCLUDE_DIR} ${GLEW_INCLUDE_DIRS} ${GLM_INCLUDE_DIRS} ${PNG_INCLUDE_DIRS} ${FREETYPE_INCLUDE_DIRS})

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutMapOpenGL PROPERTIES
  		FRAMEWORK TRUE
  		FRAMEWORK_VERSION C
  		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
  		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
  		PUBLIC_HEADER     "${HEADER_FILES}"
  		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutMapOpenGL")
endif()

=== libosmscout-map/CMakeLists.txt ===
set(HEADER_FILES
	include/osmscoutmap/MapImportExport.h
	include/osmscoutmap/oss/Parser.h
	include/osmscoutmap/oss/Scanner.h
	include/osmscoutmap/LabelLayouter.h
	include/osmscoutmap/MapPainter.h
	include/osmscoutmap/MapParameter.h
	include/osmscoutmap/MapData.h
	include/osmscoutmap/MapService.h
	include/osmscoutmap/LabelProvider.h
	include/osmscoutmap/LabelPath.h
	include/osmscoutmap/Styles.h
	include/osmscoutmap/StyleDescription.h
	include/osmscoutmap/StyleConfig.h
	include/osmscoutmap/StyleProcessor.h
	include/osmscoutmap/DataTileCache.h
	include/osmscoutmap/MapTileCache.h
	include/osmscoutmap/MapPainterNoOp.h
	include/osmscoutmap/SymbolRenderer.h
	${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutmap/MapFeatures.h
)

set(SOURCE_FILES
	src/osmscoutmap/oss/Parser.cpp
	src/osmscoutmap/oss/Scanner.cpp
	src/osmscoutmap/LabelLayouter.cpp
	src/osmscoutmap/MapPainter.cpp
	src/osmscoutmap/MapParameter.cpp
	src/osmscoutmap/MapData.cpp
	src/osmscoutmap/MapService.cpp
	src/osmscoutmap/LabelProvider.cpp
	src/osmscoutmap/LabelPath.cpp
	src/osmscoutmap/Styles.cpp
	src/osmscoutmap/StyleDescription.cpp
	src/osmscoutmap/StyleConfig.cpp
	src/osmscoutmap/StyleProcessor.cpp
	src/osmscoutmap/DataTileCache.cpp
	src/osmscoutmap/MapTileCache.cpp
	src/osmscoutmap/MapPainterNoOp.cpp
	src/osmscoutmap/SymbolRenderer.cpp
)

osmscout_library_project(
	NAME OSMScoutMap
	ALIAS Map
	OUTPUT_NAME "osmscout_map"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR "osmscoutmap"
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutmap/MapFeatures.h.cmake
	FEATURE ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutmap/MapFeatures.h
	TARGET OSMScout::OSMScout
)

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutMap PROPERTIES
  		FRAMEWORK TRUE
  		FRAMEWORK_VERSION A
  		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
  		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
  		PUBLIC_HEADER     "${HEADER_FILES}"
  		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutMap")
endif()

=== libosmscout/CMakeLists.txt ===
# Uncomment to force marisa lib
#set(MARISA_FOUND 1)

set(HEADER_FILES_ROOT
    include/osmscout/CoreImportExport.h
    include/osmscout/Area.h
    include/osmscout/AreaAreaIndex.h
    include/osmscout/AreaDataFile.h
    include/osmscout/AreaIndex.h
    include/osmscout/AreaNodeIndex.h
    include/osmscout/AreaRouteIndex.h
    include/osmscout/AreaWayIndex.h
    include/osmscout/CoordDataFile.h
    include/osmscout/CoverageIndex.h
    include/osmscout/BoundingBoxDataFile.h
    include/osmscout/TypeDistributionDataFile.h
    include/osmscout/Database.h
    include/osmscout/DataFile.h
    include/osmscout/ElevationService.h
    include/osmscout/BasemapDatabase.h
    include/osmscout/DebugDatabase.h
    include/osmscout/GeoCoord.h
    include/osmscout/GroundTile.h
    include/osmscout/Intersection.h
    include/osmscout/Location.h
    include/osmscout/LocationIndex.h
    include/osmscout/LocationService.h
    include/osmscout/LocationDescriptionService.h
    include/osmscout/Node.h
    include/osmscout/NodeDataFile.h
    include/osmscout/NumericIndex.h
    include/osmscout/ObjectRef.h
    include/osmscout/OptimizeAreasLowZoom.h
    include/osmscout/OptimizeWaysLowZoom.h
    include/osmscout/Path.h
    include/osmscout/Pixel.h
    include/osmscout/Point.h
    include/osmscout/POIService.h
    include/osmscout/PTRouteDataFile.h
    include/osmscout/PublicTransport.h
    include/osmscout/ObjectVariantDataFile.h
    include/osmscout/Route.h
    include/osmscout/RouteDataFile.h
    include/osmscout/SRTM.h
    include/osmscout/Tag.h
    include/osmscout/TypeConfig.h
    include/osmscout/TypeFeature.h
    include/osmscout/TypeFeatures.h
    include/osmscout/TypeInfoSet.h
    include/osmscout/FeatureReader.h
    include/osmscout/OSMScoutTypes.h
    include/osmscout/WaterIndex.h
    include/osmscout/Way.h
    include/osmscout/WayDataFile.h
    include/osmscout/CoreFeatures.h)

set(HEADER_FILES_OST
    include/osmscout/ost/Parser.h
    include/osmscout/ost/Scanner.h)

set(HEADER_FILES_SYSTEM
    include/osmscout/system/Assert.h
    include/osmscout/system/Compiler.h
    include/osmscout/system/Math.h
    include/osmscout/system/SSEMath.h
    include/osmscout/system/SSEMathPublic.h
    include/osmscout/system/SystemTypes.h)

set(HEADER_FILES_UTIL
    include/osmscout/util/Base64.h
    include/osmscout/util/Bearing.h
    include/osmscout/util/Breaker.h
    include/osmscout/util/Cache.h
    include/osmscout/util/Color.h
    include/osmscout/util/CmdLineParsing.h
    include/osmscout/util/Distance.h
    include/osmscout/util/Exception.h
    include/osmscout/util/File.h
    include/osmscout/util/FileScanner.h
    include/osmscout/util/FileWriter.h
    include/osmscout/util/HTMLWriter.h
    include/osmscout/util/Locale.h
    include/osmscout/util/GeoBox.h
    include/osmscout/util/Geometry.h
    include/osmscout/util/Logger.h
    include/osmscout/util/Magnification.h
    include/osmscout/util/MemoryMonitor.h
    include/osmscout/util/NodeUseMap.h
    include/osmscout/util/Number.h
    include/osmscout/util/NumberSet.h
    include/osmscout/util/ObjectPool.h
    include/osmscout/util/Parsing.h
    include/osmscout/util/PolygonCenter.h
    include/osmscout/util/ProcessingQueue.h
    include/osmscout/util/Progress.h
    include/osmscout/util/Projection.h
    include/osmscout/util/ScreenBox.h
    include/osmscout/util/ScopeGuard.h
    include/osmscout/util/StopClock.h
    include/osmscout/util/String.h
    include/osmscout/util/StringMatcher.h
    include/osmscout/util/SunriseSunset.h
    include/osmscout/util/TagErrorReporter.h
    include/osmscout/util/Tiling.h
    include/osmscout/util/Time.h
    include/osmscout/util/TileId.h
    include/osmscout/util/Transformation.h
    include/osmscout/util/Worker.h
    include/osmscout/util/WorkQueue.h
    include/osmscout/util/utf8helper.h
    include/osmscout/util/utf8helper_charmap.h
  )

set(HEADER_FILES_ROUTING
    include/osmscout/routing/RouteData.h
    include/osmscout/routing/RouteDescription.h
    include/osmscout/routing/RouteNode.h
    include/osmscout/routing/RouteNodeDataFile.h
    include/osmscout/routing/RoutePostprocessor.h
    include/osmscout/routing/RoutingDB.h
    include/osmscout/routing/RoutingProfile.h
    include/osmscout/routing/RoutingService.h
    include/osmscout/routing/AbstractRoutingService.h
    include/osmscout/routing/SimpleRoutingService.h
    include/osmscout/routing/MultiDBRoutingService.h
    include/osmscout/routing/DBFileOffset.h
    include/osmscout/routing/TurnRestriction.h
    include/osmscout/routing/MultiDBRoutingState.h
    include/osmscout/routing/RouteDescriptionPostprocessor.h)

set(HEADER_FILES_NAVIGATION
    include/osmscout/navigation/Agents.h
    include/osmscout/navigation/ArrivalEstimateAgent.h
    include/osmscout/navigation/DataAgent.h
    include/osmscout/navigation/PositionAgent.h
    include/osmscout/navigation/RouteStateAgent.h
    include/osmscout/navigation/Engine.h
    include/osmscout/navigation/Navigation.h
    include/osmscout/navigation/BearingAgent.h
    include/osmscout/navigation/RouteInstructionAgent.h
    include/osmscout/navigation/SpeedAgent.h
    include/osmscout/navigation/VoiceInstructionAgent.h
    include/osmscout/navigation/LaneAgent.h)

set(SOURCE_FILES
    src/osmscout/ost/Parser.cpp
    src/osmscout/ost/Scanner.cpp
    src/osmscout/system/SSEMath.cpp
    src/osmscout/util/Bearing.cpp
    src/osmscout/util/Breaker.cpp
    src/osmscout/util/Cache.cpp
    src/osmscout/util/Color.cpp
    src/osmscout/util/Distance.cpp
    src/osmscout/util/Exception.cpp
    src/osmscout/util/File.cpp
    src/osmscout/util/FileScanner.cpp
    src/osmscout/util/FileWriter.cpp
    src/osmscout/util/HTMLWriter.cpp
    src/osmscout/util/Locale.cpp
    src/osmscout/util/GeoBox.cpp
    src/osmscout/util/Geometry.cpp
    src/osmscout/util/Logger.cpp
    src/osmscout/util/Magnification.cpp
    src/osmscout/util/MemoryMonitor.cpp
    src/osmscout/util/NodeUseMap.cpp
    src/osmscout/util/Number.cpp
    src/osmscout/util/NumberSet.cpp
    src/osmscout/util/Parsing.cpp
    src/osmscout/util/PolygonCenter.cpp
    src/osmscout/util/Progress.cpp
    src/osmscout/util/Projection.cpp
    src/osmscout/util/ScreenBox.cpp
    src/osmscout/util/StopClock.cpp
    src/osmscout/util/String.cpp
    src/osmscout/util/StringMatcher.cpp
    src/osmscout/util/Tiling.cpp
    src/osmscout/util/TileId.cpp
    src/osmscout/util/Transformation.cpp
    src/osmscout/util/Worker.cpp
    src/osmscout/util/utf8helper.cpp
    src/osmscout/util/utf8helper_charmap.cpp
    src/osmscout/util/WorkQueue.cpp
    src/osmscout/util/SunriseSunset.cpp
    src/osmscout/util/TagErrorReporter.cpp
    src/osmscout/routing/RouteData.cpp
    src/osmscout/routing/RouteDescription.cpp
    src/osmscout/routing/RouteNode.cpp
    src/osmscout/routing/RouteNodeDataFile.cpp
    src/osmscout/routing/RoutePostprocessor.cpp
    src/osmscout/routing/RoutingDB.cpp
    src/osmscout/routing/RoutingProfile.cpp
    src/osmscout/routing/RoutingService.cpp
    src/osmscout/routing/AbstractRoutingService.cpp
    src/osmscout/routing/SimpleRoutingService.cpp
    src/osmscout/routing/MultiDBRoutingService.cpp
    src/osmscout/routing/TurnRestriction.cpp
    src/osmscout/routing/MultiDBRoutingState.cpp
    src/osmscout/routing/RouteDescriptionPostprocessor.cpp
    src/osmscout/navigation/Agents.cpp
    src/osmscout/navigation/ArrivalEstimateAgent.cpp
    src/osmscout/navigation/BearingAgent.cpp
    src/osmscout/navigation/DataAgent.cpp
    src/osmscout/navigation/PositionAgent.cpp
    src/osmscout/navigation/RouteStateAgent.cpp
    src/osmscout/navigation/RouteInstructionAgent.cpp
    src/osmscout/navigation/SpeedAgent.cpp
    src/osmscout/navigation/Engine.cpp
    src/osmscout/navigation/VoiceInstructionAgent.cpp
    src/osmscout/navigation/LaneAgent.cpp
    src/osmscout/Area.cpp
    src/osmscout/AreaDataFile.cpp
    src/osmscout/AreaAreaIndex.cpp
    src/osmscout/AreaIndex.cpp
    src/osmscout/AreaNodeIndex.cpp
    src/osmscout/AreaRouteIndex.cpp
    src/osmscout/AreaWayIndex.cpp
    src/osmscout/CoordDataFile.cpp
    src/osmscout/CoverageIndex.cpp
    src/osmscout/BoundingBoxDataFile.cpp
    src/osmscout/TypeDistributionDataFile.cpp
    src/osmscout/Database.cpp
    src/osmscout/DebugDatabase.cpp
    src/osmscout/BasemapDatabase.cpp
    src/osmscout/GeoCoord.cpp
    src/osmscout/GroundTile.cpp
    src/osmscout/Intersection.cpp
    src/osmscout/Location.cpp
    src/osmscout/LocationIndex.cpp
    src/osmscout/LocationService.cpp
    src/osmscout/LocationDescriptionService.cpp
    src/osmscout/Node.cpp
    src/osmscout/NodeDataFile.cpp
    src/osmscout/NumericIndex.cpp
    src/osmscout/ObjectRef.cpp
    src/osmscout/OptimizeAreasLowZoom.cpp
    src/osmscout/OptimizeWaysLowZoom.cpp
    src/osmscout/Path.cpp
    src/osmscout/Pixel.cpp
    src/osmscout/Point.cpp
    src/osmscout/POIService.cpp
    src/osmscout/PTRouteDataFile.cpp
    src/osmscout/PublicTransport.cpp
    src/osmscout/ObjectVariantDataFile.cpp
    src/osmscout/Route.cpp
    src/osmscout/RouteDataFile.cpp
    src/osmscout/SRTM.cpp
    src/osmscout/Tag.cpp
    src/osmscout/TypeConfig.cpp
    src/osmscout/TypeFeature.cpp
    src/osmscout/TypeFeatures.cpp
    src/osmscout/TypeInfoSet.cpp
    src/osmscout/FeatureReader.cpp
    src/osmscout/OSMScoutTypes.cpp
    src/osmscout/WaterIndex.cpp
    src/osmscout/Way.cpp
    src/osmscout/WayDataFile.cpp
    src/osmscout/util/CmdLineParsing.cpp)

set(EXCLUDE_HEADER)

if(MARISA_FOUND)
    list(APPEND HEADER_FILES_ROOT include/osmscout/TextSearchIndex.h)
    list(APPEND SOURCE_FILES src/osmscout/TextSearchIndex.cpp)
else()
    list(APPEND EXCLUDE_HEADER TextSearchIndex.h)
endif()

set(HEADER_FILES
    ${HEADER_FILES_ROOT}
    ${HEADER_FILES_OST}
    ${HEADER_FILES_SYSTEM}
    ${HEADER_FILES_UTIL}
    ${HEADER_FILES_ROUTING}
    ${HEADER_FILES_NAVIGATION})

osmscout_library_project(
    NAME OSMScout
    ALIAS OSMScout
    OUTPUT_NAME "osmscout"
    SOURCE ${SOURCE_FILES}
    HEADER ${HEADER_FILES}
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscout/CoreFeatures.h.cmake
    EXCLUDE ${EXCLUDE_HEADER}
)

if(MARISA_FOUND)
    target_include_directories(OSMScout PRIVATE ${MARISA_INCLUDE_DIRS})
    target_link_libraries(OSMScout ${MARISA_LIBRARIES})
endif()

if (ICONV_FOUND)
    target_include_directories(OSMScout PRIVATE ${ICONV_INCLUDE_DIRS})
    target_link_libraries(OSMScout ${ICONV_LIBRARIES})
endif()

if(CMAKE_THREAD_LIBS_INIT)
    target_link_libraries(OSMScout ${CMAKE_THREAD_LIBS_INIT})
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL "8.3"))
    # GCC <= 8.3 needs explicit filesystem library linking
    target_link_libraries(OSMScout -lstdc++fs)
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
    set_source_files_properties(${HEADER_FILES_ROOT}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers)
    set_source_files_properties(${HEADER_FILES_OST}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/ost)
    set_source_files_properties(${HEADER_FILES_SYSTEM}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/system)
    set_source_files_properties(${HEADER_FILES_UTIL}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/util)
    set_source_files_properties(${HEADER_FILES_ROUTING}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/routing)
    set_source_files_properties(${HEADER_FILES_NAVIGATION}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/navigation)

    set_target_properties(OSMScout PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION A
        MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
        #MACOSX_FRAMEWORK_INFO_PLIST Info.plist
        CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
        OUTPUT_NAME "OSMScout")

     install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscout DESTINATION include FILES_MATCHING PATTERN "*.h" PATTERN "private/Config.h" EXCLUDE)
endif()

=== PKGBUILD ===
# Maintainer: Adrian Jaekel <adrian at arteco dot de>

_realname=libosmscout
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2023.03.30.1
pkgrel=3
pkgdesc="A Library for offline map rendering, routing and location lookup based on OpenStreetMap data (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/Framstag/libosmscout"
license=('spdx:LGPL-2.0-only')
depends=("${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-freeglut"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-glm"
         "${MINGW_PACKAGE_PREFIX}-harfbuzz"
         "${MINGW_PACKAGE_PREFIX}-iconv"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-marisa"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-qt5-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt5-svg"
         "${MINGW_PACKAGE_PREFIX}-qt5-location"
         "${MINGW_PACKAGE_PREFIX}-qt5-multimedia"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-qt5-tools")
# imagemagick also installs "bin/import.exe"
conflicts=("${MINGW_PACKAGE_PREFIX}-imagemagick")
source=(${_realname}-${pkgver}.tar.gz::https://github.com/Framstag/libosmscout/archive/v${pkgver}.tar.gz
        001-fix-install-destinations.patch
        002-fix-build-with-libxml2-2.12.patch::https://github.com/Framstag/libosmscout/commit/db7b307d.patch)
sha256sums=('b51dc4ecbced421ed9db6359567be030c77f781b0da09830c0f2b06f675d004d'
            '1b57cf69903dacea4a6854991b83c9523a9f23b98ad39a7b773462802d8860ab'
            '7827e708586cd5f3385a19940fd9d627bdea3df244dbc016413c851f76f76e97')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-install-destinations.patch
  patch -p1 -i "${srcdir}"/002-fix-build-with-libxml2-2.12.patch
}

build() {
  mkdir "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  if check_option "debug" "y"; then
    _build_type="Debug"
  else
    _build_type="Release"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=${_build_type} \
    -DOSMSCOUT_BUILD_TESTS=OFF \
    -DOSMSCOUT_BUILD_DEMOS=OFF \
    -DOSMSCOUT_INSTALL_QT_DLL=OFF \
    -DDirect2D_D2D1_LIBRARY=${MINGW_PREFIX}/lib/libd2d1.a \
    -DDirect2D_DWRITE_LIBRARY=${MINGW_PREFIX}/lib/libdwrite.a \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .
}
